10 'I/O Board setup
20 OPEN "COM1:9600, 256, 6000" AS #1
30 SETPIN 17, 8 : SETPIN 19, 8 : SETPIN 20, 8 ' SETPIn 18, 8 removed due to firmware bug
40 SETPIN 11, 2 : SETPIN 14, 2 ' Rem for Serial port : SETPIN 15, 2 : SETPIN 16, 2
50 SETPIN 1, 1 : SETPIN 2, 1 : SETPIN 3, 1 : SETPIN 4, 1 : SETPIN 5, 1
60 SETPIN 6, 1 : SETPIN 7, 1 : SETPIN 8, 1 : SETPIN 9, 1 : SETPIN 10, 1
70 GOSUB 5000 ' Go get the Time if you do not have a RTC rem this line

80 CLS
90 GOSUB 3000

100 LOCATE 2,2 : PRINT TIME$
110 ' LOCATE 2,10 : PRINT DATE$

120 GOSUB 400

130 IF loopcount < 100 THEN 120
140 loopcount = 0
150 GOSUB 500
160 IF loopcount < 100 THEN 150
170 loopcount = 0
180 GOSUB 600
190 IF loopcount < 100 THEN 180
200 loopcount = 0
210 GOSUB 700
220 IF loopcount < 100 THEN 210
230 loopcount = 0
240 GOSUB 800
250 IF loopcount < 100 THEN 240
260 loopcount = 0
270 GOSUB 900
280 IF loopcount < 100 THEN 270
290 loopcount = 0
300 GOSUB 2000
310 GOTO 100


400 REM Voltage read
410 Volt = PIN(10) / (1.943 / 9.46) ' Input A1
420 Volts = Volts + Volt
430 loopcount = loopcount + 1
440 RETURN

500 REM Temp 1 read
510 itemp = PIN(1) * .996 ' Input A10
520 itemp = (itemp - 2.73) * 100
530 inttemp = inttemp + itemp
540 loopcount = loopcount + 1
550 RETURN

600 extemp = PIN(9) / .197 ' Input A2
610 exemp = exemp + extemp
620 loopcount = loopcount + 1
630 RETURN

700 boost = PIN(8) / .633934  ' Input A3
710 boosta = boosta + boost
720 loopcount = loopcount + 1
730 RETURN

800 AFRT = PIN(7)  ' Input A4
810 AFRT = AFRT * (2.3 / 1.44)
820 AFR= AFRT + AFR
830 loopcount = loopcount + 1
840 RETURN


900 REM Out Temp read
910 xtemp = PIN(2) * .996 'Remember to set outtemp
920 xtemp = (xtemp - 2.73) * 100
930 outtemp = outtemp + xtemp
940 loopcount = loopcount + 1
950 RETURN


2000 REM print
2010 Volts = Volts / 100
2020 volts$ = FORMAT$(volts,"%4.1f")
2030 numeric$ = volts$
2040 h=20 : w=15 : x=120 : y=20 : r=2 : s=3 ' set big number display paramters
2050 GOSUB 4000
2060 volts = 0


2100 REM print
2110 inttemp = inttemp / 100
2120 inttemp = CINT(inttemp)
2130 numeric$ = FORMAT$(inttemp,"%2.0f")
2140 h=20 : w=15 : x=260 : y=20 : r=2 : s=6 ' set big number display paramters
2150 intemp$ = numeric$
2160 GOSUB 4000
2170 inttemp = 0


2200 REM print
2210 ' exemp = exemp / 100 ' 100 samples
2220 ' exemp = exemp * 100 ' Get it back into degrees 
2230 exemp = CINT(exemp)
2240 numeric$ = FORMAT$(exemp,"%4.0f")
2250 h=20 : w=15 : x=130 : y=90 : r=2 : s=6 ' set big number display paramters
2260 exhtemp$ = numeric$
2270 GOSUB 4000
2280 exemp = 0


2300 'print Boost
2310 boosta = boosta / 100
2320 boosta = ((boosta * .9) - 1.400 ) * 14.5
2330 boosta = CINT(boosta)
2340 numeric$ = FORMAT$(boosta,"%3.0f")
2350 h=20 : w=15 : x=250 : y=90 : r=2 : s=6 ' set big number display paramters
2360 boost$ = numeric$
2370 GOSUB 4000
2380 boosta = 0


2400 ' Print AFR
2410 AFRT = AFR / 100
2420 AFR = (AFRT * 3.008) + 7.35
2430 numeric$ = FORMAT$(AFR,"%5.2f")
2440 h=20 : w=15 : x=120 : y=160 : r=2 : s=6 ' set big number display paramters
2450 afr$ = numeric$
2460 GOSUB 4000
2470 afr = 0


2500 ' print external Temp
2510 outtemp = outtemp / 100
2520 outtemp = CINT(outtemp)
2530 numeric$ = FORMAT$(outtemp,"%2.0f")
2540 h=20 : w=15 : x=260 : y=160 : r=2 : s=6 ' set big number display paramters
2550 outtemp$ = numeric$
2560 GOSUB 4000
2570 outtemp = 0

2900 return


3000 ' Screen routine
3010 CLS
3020 hres = 304 -1
3030 vres = 216 -1
3040 LINE (0, 0) - (hres, vres),1 ,B
3050 LOCATE 112,1
3060 PRINT "EVO Statistics"
3070 LOCATE 10,30 : PRINT "Voltage                  v"
3080 LOCATE 175,30 : PRINT "Cabin Temp         C"
3090 LOCATE 10,100 : PRINT"Manifold                 C"
3100 LOCATE 175,100 : PRINT"Boost            PSI"
3110 LOCATE 10,170 : PRINT"AFR"
3120 LOCATE 175,170 : PRINT "Ext Temp          C"
3130 RETURN



4000 ' BIG Number routine
4010 'h = Numeric Height in pixels
4020 'w = Numeric Width in pixels
4030 'x = X axis start position, right justified.
4040 'y = Y axis position, top edge of number
4050 'r = Decimal point radius in pixels.
4060 's = Spacing between numbers in pixels
4070  StringLength=LEN(Numeric$)
4080  FOR StringLoc=StringLength TO 1 STEP -1
4090  LINE(x,y)-(x+w,y+h),0,"BF"
4100  n$=MID$(Numeric$,StringLoc,1)
4110  IF n$="0" THEN LINE(x,y)-(x+w,y+h),1,"B"
4120  IF n$="1" THEN LINE(x+w,y)-(x+w,y+h),1
4130  IF n$="2" THEN LINE(x,y)-(x+w,y),1 : LINE(x+w,y)-(x+w,y+(h/2)),1 : LINE(x+w,y+(h/2))-(x,y+(h/2)),1 : LINE(x,y+(h/2))-(x,y+H),1 : LINE(x,y+h)-(x+w,y+h),1
4140  IF n$="3" THEN LINE(x,y)-(x+w,y),1 : LINE(x+w,y)-(x+w,y+h),1 : LINE(x+w,y+h)-(x,y+h),1 : LINE(x,y+(h/2))-(x+w,y+(h/2)),1
4150  IF n$="4" THEN LINE(x,y)-(x,y+(h/2)),1 : LINE(x,y+(h/2))-(x+w,y+(h/2)),1 : LINE(x+w,y)-(x+w,y+H),1
4160  IF n$="5" THEN LINE(x,y)-(x+w,y),1 : LINE(x,y)-(x,y+(h/2)),1 : LINE(x,y+(h/2))-(x+w,y+(h/2)),1 : LINE(x+w,y+(h/2))-(x+w,y+h),1 : LINE(x,y+h)-(x+w,y+h),1
4170  IF n$="6" THEN LINE(x+w,y)-(x,y),1 : LINE(x,y)-(x,y+(h/2)),1 : LINE(x,y+(h/2))-(x+w,y+h),1,"B"
4180  IF n$="7" THEN LINE(x,y)-(x+w,y),1 : LINE(x+w,y)-(x+w,y+h),1
4190  IF n$="8" THEN LINE(x,y)-(x+w,y+h),1,"B" : LINE(x,y+(h/2))-(x+w,y+(h/2)),1
4200  IF n$="9" THEN LINE(x,y+h)-(x+w,y+h),1 : LINE(x+w,y+h)-(x+w,y+(h/2)),1 : LINE(x,y)-(x+w,y+(h/2)),1,"B"
4210  IF n$="." THEN CIRCLE(x+(W/2),y+(h/2)),r
4220  IF n$="-" THEN LINE(x+w,y+(h/2))-(x,y+(h/2)),1
4230  x=x-w-S
4240  NEXT
4250 return



5000 ' I2C RTC based On PCF8563 Secs,Mins,Hours,Day,Date,Month,Year
5010 DIM RTCbuff(255)
5020 i2caddr = &h51 ' PCF8563 I2C address
5030 I2CEN 100,100 ' Enable I2C
5040 I2CRCV i2caddr, 0, 7, RTCbuff(0), 1, 2
5050 I2CDIS
5060 BCDTEMP = RTCBuff(0) AND &H7F ' Mask unwanted bits
5070 GOSUB 5310
5080 sec$ = STR$(decimal)
5090 BCDTEMP = RTCBuff(1) AND &H7F ' Mask unwanted bits
5100 GOSUB 5310
5110 min$ = STR$(decimal)
5120 BCDTEMP = RTCBuff(2) AND &H3f ' Mask unwanted bits
5130 GOSUB 5310
5140 hours$ = STR$(decimal)
5150 BCDTEMP = RTCBuff(3) AND &H3f ' Mask unwanted bits
5160 GOSUB 5310
5170 day$ = STR$(decimal)
5180 BCDTEMP = RTCBuff(5) AND &h1F ' Mask unwanted bits
5190 GOSUB 5310
5200 month$ = STR$(decimal)
5210 bcdtemp = rtcbuff(6)
5220 GOSUB 5310
5230 year$ = STR$(decimal + 2000 )
5240 t$ = hours$+":"+min$+":"+sec$
5250 D$ = day$+"/"+month$+"/"+year$
5260 TIME$ = T$
5270 DATE$ = D$
5280 ' ? "Time has been set to ";T$
5290 ' ?"Date has been set to ";D$
5300 RETURN

5310 ' Convert to Decimal
5320 Decimal = FIX(BCDTemp / 16) * 10
5330 Decimal = Decimal + (BCDTEMP AND &hF)
5340 RETURN



6000 ' Serial interupt routine
6010 serial$ = INPUT$(1, 1)
6020 IF serial$ = "V" THEN
6030 PRINT #1, "V" + volts$ : ENDIF
6040 IF serial$ = "M" THEN
6050 PRINT #1, "M" + exhtemp$ : ENDIF
6060 IF serial$ = "B" THEN
6070 PRINT #1, "B" + boost$ : ENDIF
6080 IF serial$ = "A" THEN
6090 PRINT #1, "A" + afr$ : ENDIF
6100 IF serial$ = "O" THEN
6110 PRINT #1, "O" + outtemp$ : ENDIF
6120 IF serial$ = "T" THEN
6130 PRINT #1, "T" + intemp$ : ENDIF
6140 ' endif
6150 IRETURN



